      PROGRAM RC3D
C
C  THIS PROGRAM READS AND TYPES A FRAME OF DATA FROM A .C3D FILE
C  THE LISTING WAS REPRODUCED FROM ANDREW'S PROGRAM RDFRME
C
      INTEGER*2 DTYP,NPTS,AVRAT,FRN,SC(2),CBIT(7)
      REAL*4 FROUT(400)
      LOGICAL*1 FNAM(40)
      EQUIVALENCE (SC(1),SCALE)
C
5     DO 4 I=1,40
4     FNAM(I)=0
      OPEN(UNIT=2,NAME='RAJESH:TEM.TXT;1',TYPE='OLD')
C      TYPE *,'ENTER .C3D FILE NAME '
      READ(2,121) (FNAM(I),I=1,40)
121   FORMAT(40A1)
      Fnam(24)='C'
      Fnam(25)='3'
      Fnam(26)='D'
C
      IVLA=0
      LU=2
      OPEN(UNIT=2,NAME=FNAM,TYPE='OLD',ACCESS='DIRECT',
     *RECORDSIZE=128,ERR=222)
C
20    READ(2'1)I,NPTS,NANLG,IF1,IF2,I,SC(1),SC(2),IH,AVRAT
C      TYPE *,NPTS,NANLG,IF1,IF2,I,SC(1),SC(2),IH,AVRAT
C
      FNAM(24)='T'
      FNAM(25)='R'
      FNAM(26)='I'
      OPEN(UNIT=3,NAME=FNAM,TYPE='NEW')
      WRITE(3,*) NPTS,IF1,IF2
C
      IF(AVRAT.GT.0) GOTO 45
C      TYPE *,'ENTER ANALOG/VIDEO FRAME RATE RATIO : '
C      ACCEPT *,AVRAT
      AVRAT=1
45    NANLG=NANLG/AVRAT
C      TYPE *,' '
C      TYPE *,'NUMBER OF POINTS                    ',NPTS
C      TYPE *,'NUMBER OF VIDEO FRAMES              ',IF2-IF1+1
C      TYPE *,'NUMBER OF ANALOG CHANNEL            ',NANLG
C      IF(NANLG.GT.0) TYPE *,' ANALOG/VIDEO FRAME RATE = ',AVRAT
C15    TYPE *,'OUTPUT OF VIDEO-ANALOG FRAMES OR ANALOG FRAMES(1/2) ? '
C      ACCEPT *,DTYP
15    DTYP=1
      IF(DTYP.LT.1.OR.DTYP.GT.2)GOTO 15
      IF(DTYP.EQ.1) GOTO 10
      IF(NANLG.GT.0) GOTO 10
      TYPE *,'NO ANALOG DATA IN THIS FILE '
      GOTO 15
C
C10    TYPE *,' '
C      TYPE *,'ENTER FRAME NUMBER ' 
C      ACCEPT *,FRN
10    DO 1111 FRN=1,IF2-IF1+1
C
      IF(FRN.EQ.0) GOTO 20
C
C      TYPE *,' '
      CALL GETF(LU,DTYP,FRN,NPTS,NANLG,AVRAT,FROUT,IH,IVLA,SCALE)
      IF(IVLA.GT.0) GOTO 87
      TYPE *,'ERROR IN READING FRAME',FRN
      GOTO 10
87    IF(DTYP.EQ.2) GOTO 25
      K=-3
      IF(NPTS.EQ.0) GOTO 28
      DO 22 I=1,NPTS
      K=(I-1)*4+1
      RES=-1.0
      IF(FROUT(K+3).LT.0.0) GOTO 29
      RES=(IFIX(FROUT(K+3)).AND."377)*SCALE
C
C  DECODE CAMERA BITS
C
29    JJ=IFIX(FROUT(K+3))/256
      DO 60 J=1,7
      CBIT(8-J)=0
      IF((JJ.AND.1).NE.0) CBIT(8-j)=1
60    JJ=JJ/2
      WRITE(3,*) (FROUT(J)*SCALE,J=K,K+2)
c103   FORMAT(1X,3F12.3)
C
C22    WRITE(5,100) I,(FROUT(J)*SCALE,J=K,K+2),
C     *RES,(CBIT(J),J=1,7)
C100   FORMAT(I5,8X,3F12.3,F10.3,5X,7I1)
22    CONTINUE
C28    WRITE(5,110) (FROUT(I),i=k+4,K+3+NANLG)
28    CONTINUE
C      GOTO 10
      GOTO 1111
25    WRITE(5,110) (FROUT(I),i=1,NANLG)
110   FORMAT(1X,8F8.0)
C
C      GOTO 10
1111  CONTINUE
      GOTO 333
222   TYPE *,'*** C3D FILE DOES NOT EXIST'
      TYPE *,'***     DO NOT PROCEED'
333   END
C
C  SUBROUTINE TO FETCH 1 FRAME OF DATA FROM .C3D FILE
C
      SUBROUTINE GETF(LU,DTYP,FRN,NPTS,NANLG,AVRAT,FROUT,IH,IVLA,SCALE)
C 
C  IF THE SCALE FACTOR IS NEGATIVE THEN THE DATA IS ASSUMED TO BE 
C  STORED IN REAL*4 FORMAT IN THE .C3D FILE
C
C  INPUT
C
      INTEGER*2 LU       ! LOGICAL UNIT NUMBER
      INTEGER*2 DTYP     ! =1 FOR TR3+ADC  AND =2 FOR ADC ONLY AT HIGHER RATE
      INTEGER*2 FRN      ! FRAME NUMBER
      INTEGER*2 NPTS     ! NUMBER OF MARKERS IN VIDEO FRAME
      INTEGER*2 NANLG    ! NUMBER OF ANALOG WORDS IN ANALOG FRAME
      INTEGER*2 AVRAT    ! RATIO OF ANALOG TO VIDEO FRAME RATE
      INTEGER*2 IH       ! NUMBER OF FIRST DATA IN RECORD FILE
      INTEGER*2 IVLA     ! DATA RECORD POINTER, INITIALLY 0
C                        ! IVLA IS SET TO -1 IF ERROR IN GETTING DATA
      REAL*4    SCALE    ! SCALE FACTOR FOR INTEGER DATA IN C3D FILE
C
C  OUTPUT
C
      REAL*4    FROUT(1) ! OUTPUT DATA FRAME
      INTEGER*2 IBUF(256)  ! RECORD BUFFER
      REAL*4    RBUF(128)  !   "      "
C
      EQUIVALENCE (IBUF(1),RBUF(1))
C
      IRE =0                       ! INTEGER DATA FILE
      IBZ =256                     ! RECORD LENGTH
      IF(SCALE.GE.0.0) GOTO 7
      IRE=1                        ! REAL*4 DATA FILE
      IBZ=128
7     SC=ABS(SCALE)
C
      LF=NPTS*4+NANLG*AVRAT        ! TOTAL FRAME LENGTH
      GOTO (11,12),DTYP
C
11    FP=FLOAT(FRN-1)*LF           ! WORD NUMBER FOR FRAME START-1
      GOTO 13
C
12    IFR=(FRN-1)/AVRAT            ! DATA FRAME NEEDED - 1
      INFR=FRN-IFR*AVRAT           ! ANALOG FRAME WITHIN VIDEO FRAME
      FP=FLOAT(IFR)*FLOAT(LF)+NPTS*4+(INFR-1)*NANLG
C
13    IVV=FP/FLOAT(IBZ)+.001       ! RECORD NUMBER
      J=(FP-FLOAT(IVV)*FLOAT(IBZ))+.001   ! FRAME START IN RECORD
C
C
      IVV=IVV+IH                   ! RECORD NUMBER NEEDED
      IF(IVV.EQ.IVLA)GOTO 45       ! HAVE IT , NO NEED TO READ IT
      IVLA=IVV
      READ(LU'IVLA,ERR=800) IBUF
C
45    LFF=NPTS*4+NANLG*AVRAT
      IF(DTYP.EQ.2) LFF=NANLG
C
      K=1
      DO 20 I=1,LFF                 ! TRANSFER IT TO OUTPUT FRAME
      J=J+1
      IF(J.LE.IBZ) GOTO 30
      J=1                           ! NEED NEXT RECORD
      IVLA=IVLA+1
      READ(LU'IVLA,ERR=800)IBUF
30    IF(IRE.EQ.0) FROUT(K)=IBUF(J)  ! INTEGER READ
      IF(IRE.EQ.1) FROUT(K)=RBUF(J)  ! REAL*4 READ
20    K=K+1
C
      GOTO 90
C
800   IVLA=-1   ! ERROR
C
90    RETURN
      END


